/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved. 
 * 
 *  DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 *
 *  This code is free software; you can redistribute it and/or modify it
 *  under the terms of the GNU General Public License version 3, 
 *  or (at your option) any later version, as published by the Free Software Foundation.  
 *  The authors designate this particular file as subject to the "Classpath" exception 
 *  as provided in the LICENSE file that accompanied this code.
 *
 *  This code is distributed in the hope that it will be useful, but WITHOUT
 *  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 *  version 3 for more details (a copy is included in the LICENSE file that
 *  accompanied this code).
 *
 *  You should have received a copy of the GNU General Public License version 3
 *  along with this work; if not, see http://www.gnu.org/licenses/gpl-3.0.txt 
 *
 *  Please contact visnow.org or visit www.visnow.org if you need additional information or
 *  have any questions.
 *
 */

package org.visnow.vn.lib.gui.FieldBasedUI.SubsetGUI;

import java.util.ArrayList;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

/**
 *
 * @author Krzysztof S. Nowinski, University of Warsaw, ICM
 */
public class SubsetUI extends javax.swing.JPanel
{
    private SubsetParams params = null;
    private boolean active = true;
    /**
     * Creates new form DownsizeUI
     */
    public SubsetUI()
    {
        initComponents();
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        buttonGroup1 = new javax.swing.ButtonGroup();
        preferredSizeSlider = new org.visnow.vn.gui.widgets.ExtendedSlider();
        jPanel1 = new javax.swing.JPanel();
        randomButton = new javax.swing.JRadioButton();
        regularButton = new javax.swing.JRadioButton();
        centerBox = new javax.swing.JCheckBox();

        setBorder(javax.swing.BorderFactory.createTitledBorder("preferred subset size"));
        setLayout(new java.awt.GridBagLayout());

        preferredSizeSlider.setFieldType(org.visnow.vn.gui.components.NumericTextField.FieldType.INT);
        preferredSizeSlider.setGlobalMin(1);
        preferredSizeSlider.setMax(100000);
        preferredSizeSlider.setMin(1);
        preferredSizeSlider.setScaleType(org.visnow.vn.gui.widgets.ExtendedSlider.ScaleType.LOGARITHMIC);
        preferredSizeSlider.setSubmitOnAdjusting(false);
        preferredSizeSlider.addUserActionListener(new org.visnow.vn.gui.swingwrappers.UserActionListener() {
            public void userChangeAction(org.visnow.vn.gui.swingwrappers.UserEvent evt) {
                preferredSizeSliderUserChangeAction(evt);
            }
            public void userAction(org.visnow.vn.gui.swingwrappers.UserEvent evt) {
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        add(preferredSizeSlider, gridBagConstraints);

        jPanel1.setLayout(new java.awt.GridLayout(1, 0));

        buttonGroup1.add(randomButton);
        randomButton.setSelected(true);
        randomButton.setText("random");
        randomButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                randomButtonActionPerformed(evt);
            }
        });
        jPanel1.add(randomButton);

        buttonGroup1.add(regularButton);
        regularButton.setText("regular");
        regularButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                regularButtonActionPerformed(evt);
            }
        });
        jPanel1.add(regularButton);

        centerBox.setSelected(true);
        centerBox.setText("center");
        centerBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                centerBoxActionPerformed(evt);
            }
        });
        jPanel1.add(centerBox);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(jPanel1, gridBagConstraints);
    }// </editor-fold>//GEN-END:initComponents

    private void preferredSizeSliderUserChangeAction(org.visnow.vn.gui.swingwrappers.UserEvent evt) {//GEN-FIRST:event_preferredSizeSliderUserChangeAction
        params.setAdjusting(preferredSizeSlider.isAdjusting());
        params.setSubsetSize((int)preferredSizeSlider.getValue());
    }//GEN-LAST:event_preferredSizeSliderUserChangeAction

    private void centerBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_centerBoxActionPerformed
        params.setCentered(centerBox.isSelected());
    }//GEN-LAST:event_centerBoxActionPerformed

    private void regularButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_regularButtonActionPerformed
        params.setRandom(!regularButton.isSelected());
        centerBox.setEnabled(regularButton.isSelected());
    }//GEN-LAST:event_regularButtonActionPerformed

    private void randomButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_randomButtonActionPerformed
        params.setRandom(randomButton.isSelected());
        centerBox.setEnabled(!randomButton.isSelected());
    }//GEN-LAST:event_randomButtonActionPerformed

    public void setParams(SubsetParams params)
    {
        this.params = params;
        params.setUI(this);
    }

    public void updateFromParams()
    {
        if (params == null)
            return;
        active = false;
        preferredSizeSlider.setAll(params.getMinSize(), 
                                   params.getMaxSize(), 
                                   params.getPreferredSize());
        regularButton.setSelected(params.isRegularAvailable());
        randomButton.setSelected(!params.isRegularAvailable());
    }
    
    public void showRegularDownsizeWidgets(boolean show)
    {
        regularButton.setVisible(show);
        centerBox.setVisible(show);
        centerBox.setEnabled(regularButton.isSelected());
    }
    /**
     * Utility field holding list of ChangeListeners.
     */
    private transient ArrayList<ChangeListener> changeListenerList = new ArrayList<>();

    /**
     * Registers ChangeListener to receive events.
     *
     * @param listener The listener to register.
     */
    public synchronized void addChangeListener(ChangeListener listener)
    {
        changeListenerList.add(listener);
    }

    /**
     * Removes ChangeListener from the list of listeners.
     *
     * @param listener The listener to remove.
     */
    public synchronized void removeChangeListener(ChangeListener listener)
    {
        changeListenerList.remove(listener);
    }

    /**
     * Notifies all registered listeners about the event.
     *
     * @param object Parameter #1 of the <CODE>ChangeEvent<CODE> constructor.
     */
    private void fireStateChanged()
    {
        if (active) {
            ChangeEvent e = new ChangeEvent(this);
            for (ChangeListener listener : changeListenerList)
                listener.stateChanged(e);
        }
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.ButtonGroup buttonGroup1;
    private javax.swing.JCheckBox centerBox;
    private javax.swing.JPanel jPanel1;
    private org.visnow.vn.gui.widgets.ExtendedSlider preferredSizeSlider;
    private javax.swing.JRadioButton randomButton;
    private javax.swing.JRadioButton regularButton;
    // End of variables declaration//GEN-END:variables

}
